(function ($, Drupal) {
  Drupal.behaviors.webformBookingValidation = {
    attach: function (context, settings) {
      $(context).find('form.webform-ui-element-form').once('webform-booking-validation').each(function () {
        // Delegated event handler for blur event on 'exclusion_dates'
        $(this).on('blur', 'textarea[name="properties[exclusion_dates]"]', function () {
          console.log('Exclusion dates blur event');
          const exclusionDates = $(this).val();
          const datePattern = /^(\d{4}-\d{1,2}-\d{1,2})(\|\d{4}-\d{1,2}-\d{1,2})?$/;
          const lines = exclusionDates.split('\n');
          const allLinesValid = lines.every(line => datePattern.test(line));
          if (!allLinesValid) {
            alert('Invalid Exclusion Dates\nEnter dates in format YYYY-MM-DD or intervals in format YYYY-MM-DD|YYYY-MM-DD, one per line. Ex.\n"2023-12-25\n2023-12-25|2024-01-01"');
          }
        });

        // Delegated event handler for blur event on 'time_interval'
        $(this).on('blur', 'textarea[name="properties[time_interval]"]', function () {
          const timeIntervals = $(this).val();
          const timeIntervalPattern = /^(\d{1,2}:\d{2})\|(\d{1,2}:\d{2})(\((Monday|Tuesday|Wednesday|Thursday|Friday|Saturday|Sunday)\))?$/;
          const lines = timeIntervals.split('\n');
          const allLinesValid = lines.every(line => timeIntervalPattern.test(line));
          if (!allLinesValid) {
            alert('Invalid Time Intervals\nEnter time intervals in 24h format. One interval per line. You can also add exceptions for specific days. Ex. \n"08:00|12:00\n10:00|12:00(Friday)"');
          }
        });
      });
    }
  };
})(jQuery, Drupal);
